from tkinter import *
import math
PI=math.pi
cos30=math.cos(PI/6);cos15=math.cos(PI/12)
sin30=math.sin(PI/6);sin15=math.sin(PI/12)
SC=100; X0=100; Y0=180
def scXY(x,y, z):
    global cos30, cos15, sin30, sin15, SC,X0, Y0
    R=[0 for i in range(2)]
    R[0]=int(X0+SC*(y*cos15-x*cos30)+0.5)
    R[1]=int(Y0-SC*(y*sin15+x*sin30+z)+0.5)
    return R
def setPoint(x,y, z, L, H):
    R=[0 for i in range(4)]
    R[0]=scXY(x      , y      , z)
    R[1]=scXY(x+0.5*L, y+0.5*L, z+H)
    R[2]=scXY(x+L    , y      , z)
    R[3]=scXY(x      , y+L    , z)
    return R
def colorValue(DT):
    ii=int(255*DT)
    if ii<0: return 0
    if ii>255: return 255
    return ii
PMod=False
Lmin=0.05
Beta=0.1
def pyramid(n, x, y, z, L, H, r, g, b):
    global canvas, Pmod, Lmin
    if L<Lmin:
        R=setPoint(x,y,z, L,H)
        alfa=math.exp(-Beta*math.sqrt(x*x+y*y))
        rr=alfa*r; gg=alfa*g; bb=alfa*b
        C1="#%02X%02X%02X" % (colorValue(rr), colorValue(gg), colorValue(bb))
        C2="#%02X%02X%02X" % (colorValue(rr/4), colorValue(gg/4), colorValue(bb/4))
        C3=""
        if PMod :
            C3="#%02X%02X%02X" % (colorValue(rr/8), colorValue(gg/8), colorValue(bb/8))
        canvas.create_polygon(R[0][0], R[0][1], R[1][0], R[1][1],
                              R[2][0], R[2][1], fill=C1, outline=C3)
        canvas.create_polygon(R[0][0], R[0][1], R[1][0], R[1][1],
                              R[3][0], R[3][1], fill=C2, outline=C3)
    else:
        LL=L*0.5; LZ=L*0.25; HH=H*0.5
        pyramid(n+1, x + LL, y + LL, z     , LL, HH, r+math.pow(2, -n), g, b+math.pow(2, -n))
        pyramid(n+1, x + LL, y     , z     , LL, HH, r, g+math.pow(2, -n), b+math.pow(2, -n))
        pyramid(n+1, x     , y + LL, z     , LL, HH, r, g, b+math.pow(2, -n))
        pyramid(n+1, x     , y     , z     , LL, HH, r, g+math.pow(2, -n), b)
        pyramid(n+1, x + LZ, y + LZ, z + HH, LL, HH, r+math.pow(2, -n), g, b)
root=Tk(); root.title("Sierpinski Pyramid")
canvas=Canvas(root, width=220,height=198)
canvas.pack()
pyramid(0, 0,0,0,1,1.2, 0, 0, 0)
root.update()
root.mainloop()

           
